﻿using System;
using System.Collections.Generic;
using Wisej.Web;
using WisejDGV.Models;

namespace WisejDGV
{
    public partial class CtrlDGV : Wisej.Web.UserControl
    {
        private List<ModelDGV> _dataSource;
        private List<ModelCombo> _values;


        public CtrlDGV()
        {
            InitializeComponent();

            _dataSource = new List<ModelDGV>();
            _dataSource.Add(new ModelDGV() { Val = "A" });
            _dataSource.Add(new ModelDGV() { Val = "B" });

            _values = new List<ModelCombo>();
            _values.Add(new ModelCombo() { Id = 1 });
            _values.Add(new ModelCombo() { Id = 2 });
            _values.Add(new ModelCombo() { Id = 3 });
        }

        private void CtrlDGV_Load(object sender, EventArgs e)
        {
            this.SetDataSource();
        }

        private void SetDataSource()
        {
            this.dgv.BeginUpdate();

            //this.dgv.DataSource = null;
            this.dgv.DataSource = _dataSource;
            this.SetCombobox();

            this.dgv.EndUpdate();

            this.dgv.Refresh();
        }

        private void SetCombobox()
        {
            DataGridViewRowCollection rows = this.dgv.Rows;

            if(rows.Count <= 0)
            {
                return;
            }

            foreach(DataGridViewRow row in rows)
            {
                row.DefaultCellStyle.BackColor = System.Drawing.Color.Red;

                DataGridViewComboBoxCell combo = (DataGridViewComboBoxCell)row.Cells[1];

                combo.DataSource = _values;
                combo.DisplayMember = "Id";
                combo.ValueMember = "Id";
                combo.Value = 1;

                combo.Update();
            }
        }
    }
}
